//
// old.cpp:
//	Implementation of some old 'C' functions which may or may not work.
//	They changed very little from the original 'C'.
//
//
// Author(s): See authorships in OOPGLOVE.DOC.
//	Minor changes by Mark Pflaging   C-serve  70233,1552
//
// Date:    5/15/92 - 6/4/92
//
#include "glgrph.hpp"

static int hand[20] = {
	460, 150, 480, 150, 480, 130, 500, 130, 500, 150, 520, 150,
	520, 160, 540, 160, 540, 220, 460, 220
};

static void drawBase()
{
	setfillstyle(SOLID_FILL,EGA_LIGHTGRAY);
	setcolor(EGA_LIGHTGRAY);

	fillpoly(10,hand);
}

void eraseFingers()
{
	static int empty[10] = {
		400, 40,  540, 40,  540, 222,  400, 222,  400, 40
	};
	setfillstyle(SOLID_FILL,EGA_BLACK);
	setcolor(EGA_BLACK);
	fillpoly(5, empty);
}

// Made changes 8/8/92 to adjust to "my" finger values.
void drawFingers( gloveDriver& gd )
{
	drawBase();

	// index finger

	if(gd.getIndex()==3)
	{
		rectangle(460,110,480,150);
		rectangle(460,80,480,110);
		rectangle(460,60,480,80);
	}
	if(gd.getIndex()==2)
	{
		// two blocks
		setcolor(EGA_BLACK);
		rectangle(460,110,480,150);
		rectangle(460,80,480,110);
		rectangle(460,60,480,80);

		setcolor(EGA_LIGHTGRAY);
		rectangle(460,110,480,150);
		rectangle(460,80,480,110);
	}
	if(gd.getIndex()==1)
	{
		setcolor(EGA_BLACK);
		rectangle(460,110,480,150);
		rectangle(460,80,480,110);
		rectangle(460,60,480,80);

		setcolor(EGA_LIGHTGRAY);
		rectangle(460,110,480,150);
	}
	if(gd.getIndex()==0)
	{
		setcolor(EGA_BLACK);
		rectangle(460,110,480,150);
		rectangle(460,80,480,110);
		rectangle(460,60,480,80);

		setcolor(EGA_LIGHTGRAY);
	}

	// middle finger

	if(gd.getMiddle()==3)
	{
		rectangle(480,100,500,130);
		rectangle(480,60,500,100);
		rectangle(480,40,500,60);
	}
	if(gd.getMiddle()==2)
	{
		setcolor(EGA_BLACK);
		rectangle(480,100,500,130);
		rectangle(480,60,500,100);
		rectangle(480,40,500,60);

		setcolor(EGA_LIGHTGRAY);
		rectangle(480,100,500,130);
		rectangle(480,60,500,100);
	}
	if(gd.getMiddle()==1)
	{
		setcolor(EGA_BLACK);
		rectangle(480,100,500,130);
		rectangle(480,60,500,100);
		rectangle(480,40,500,60);

		setcolor(EGA_LIGHTGRAY);
		rectangle(480,100,500,130);
	}
	if(gd.getMiddle()==0)
	{
		setcolor(EGA_BLACK);
		rectangle(480,100,500,130);
		rectangle(480,60,500,100);
		rectangle(480,40,500,60);

		setcolor(EGA_LIGHTGRAY);
	}

	// ring fingers

	if(gd.getRing()==3)
	{
		rectangle(500,50,520,70);
		rectangle(500,70,520,100);
		rectangle(500,100,520,150);

		rectangle(520,120,540,160);
		rectangle(520,90,540,120);
		rectangle(520,70,540,90);
	}
	if(gd.getRing()==2)
	{
		setcolor(EGA_BLACK);
		rectangle(500,50,520,70);
		rectangle(500,70,520,100);
		rectangle(500,100,520,150);

		rectangle(520,120,540,160);
		rectangle(520,90,540,120);
		rectangle(520,70,540,90);

		setcolor(EGA_LIGHTGRAY);
		rectangle(500,70,520,100);
		rectangle(500,100,520,150);

		rectangle(520,120,540,160);
		rectangle(520,90,540,120);
	}
	if(gd.getRing()==1)
	{
		setcolor(EGA_BLACK);
		rectangle(500,50,520,70);
		rectangle(500,70,520,100);
		rectangle(500,100,520,150);

		rectangle(520,120,540,160);
		rectangle(520,90,540,120);
		rectangle(520,70,540,90);

		setcolor(EGA_LIGHTGRAY);
		rectangle(500,100,520,150);
		rectangle(520,120,540,160);
	}
	if(gd.getRing()==0)
	{
		setcolor(EGA_BLACK);
		rectangle(500,50,520,70);
		rectangle(500,70,520,100);
		rectangle(500,100,520,150);

		rectangle(520,120,540,160);
		rectangle(520,90,540,120);
		rectangle(520,70,540,90);

		setcolor(EGA_LIGHTGRAY);
	}

	// thumb

	if(gd.getThumb()==2)
	{
		rectangle(430,160,460,200);
		rectangle(400,160,430,190);
	}
	if(gd.getThumb()==1)
	{
		setcolor(EGA_BLACK);
		rectangle(430,160,460,200);
		rectangle(400,160,430,190);

		setcolor(EGA_LIGHTGRAY);
		rectangle(430,160,460,200);
	}
	if(gd.getThumb()==0)
	{
		setcolor(EGA_BLACK);
		rectangle(430,160,460,200);
		rectangle(400,160,430,190);

		setcolor(EGA_LIGHTGRAY);
	}
}

// Ahem!
void drawGlovePlot( graphicsActor & obj, gloveDriver& gd )
{
	// plot X,Y data to test smoothing.

	if( gd.getKeys() == 4 ) {
		// restart at left edge if "4" pressed.
		cleardevice();
		obj.xx = 0;
	}

	setcolor( 0 );
	line( obj.xx, 0, obj.xx, 479 );
	line( obj.xx + 1, 0, obj.xx + 1, 479 );

	setcolor( 15 );
	line( obj.xx, 240 - 2 * gd.getX(), obj.xx + 1, 240 - 2 * gd.getX() );

	setcolor( 12 );
	line( obj.xx + 1, 240 - 2 * gd.getY(), obj.xx + 2, 240 - 2 * gd.getY() );

	obj.xx += 2;

	if( obj.xx > 639 ) {
	       obj.xx = 0;
	}
}

// The variable times_up is used as a flag
// for BIOS INT calls in settimer().
// The high bit is set when the delay is finished.
char volatile machineTimer::timer_done;

// machineTimer::settimer() is courtesy of
// Dream Park Reasearch Corporation.
// It is currently unused.
int machineTimer::settimer(unsigned long delay)
{
	static union REGS rin;
	static struct SREGS sin;
	static char far *p;

/****** but why bother?  :-)
	static int inited;
	if (!inited)		// making sure 80386 instruction cache
	{			// has code in it.
		++inited;
		fdelay(1,1,100);
	}
*************/

	// clear old ones left over from before (dos 5.0)
	// the first call is to reset the timer

	rin.x.cflag = 0;
	rin.h.ah = 0x83;
	rin.h.al = 0x01;
	rin.x.cx = 0;
	rin.x.dx = delay;
	timer_done = 0;

	p = (char far *) &timer_done;

	sin.es = FP_SEG(p);
	rin.x.bx = FP_OFF(p);

	int86x(0x15, &rin, &rin, &sin);


	//starts timer

	rin.x.cflag = 0;
	rin.h.ah = 0x83;
	rin.h.al = 0x00;
	rin.x.cx = 0;
	rin.x.dx = delay;
	timer_done = 0;

	p = (char far *) &timer_done;

	sin.es = FP_SEG(p);
	rin.x.bx = FP_OFF(p);

	int86x(0x15, &rin, &rin, &sin);

	return (rin.x.cflag == 0);
}

char machineTimer::times_up()
{
	return timer_done;
}


/*********
	// This code does a frequency analysis for 10 samples.
	// I found that averaging 100 samples worked much better.
	// It's tough to throw away code like this!
	int tries[10], found, attempts = 0;

	while (attempts < 16) {
		int current = 0;
		for (int i = 0; i < 10; i ++) {
			tries[i] = 0;
		}
		for (i = 0; i < 7; i ++) {
			int temp = count_once();
			found = 0;
			for (int j = 0; j < current; j += 2) {
				if (temp == tries[j]) {
					tries[j + 1] ++;
					found = 1;
					break;
				}
			}
			if (!found) {
				tries[current] = temp;
				tries[current + 1] ++;
			current += 2;
			}
		}
		for (i = 0; i < 10; i += 2)
			if (tries[i+1] > 4) return (tries[i]);
		attempts ++;
	}
	exit (5);
	return (0);
************/
/**********
	for (int i = 0; i < 7; i ++) {
		if (!testdelay) {
			ptimer.reset();
			ptimer.start();

			// D2BITS can be between 29 and 40 usec!!
			// D2BYTES can be between 85 and 820 usec!!
			fdelay();

			ptimer.stop();
		}
		else {
			ptimer.reset();
			ptimer.start();

			// D2BITS can be between 29 and 40 usec!!
			// D2BYTES can be between 85 and 820 usec!!
			fdelay(testdelay);

			ptimer.stop();
		}
		cout << "Count: " << ptimer.count();
		cout << "   Time: " << ptimer << " secs" << endl;
	}
*********/

/******* This is some LAME code   :-)
int cfGlove::loop(graphicsActor& gloveGraph)
{
	// begin again here if glove crashes

	if( pass++ >= 3 ) {
		closegraph();
		printf("\n Glove not responding. ");
		getch();
		exit( 0 );
	}

	// set PG into 'hires' mode
	set_glove_hiResMode();

	while( ! kbhit() )
	{
		int unready = 0;    // start polling glove
//		D2SLOW.multipliedDelay(5);

		// wait for glove to become ready
		while( ! is_glove_ready() )
		{
			if( unready++ > 50 ) {
				//exit(-1);
				//closegraph();
				//printf("\n Glove not ready.  Resetting... ");
				//end program???;
				return -1;   // reset mode if dead glove
			}
			if (unready>4) {
			//		break;
			}
//			D2SLOW.multipliedDelay(5);
		}
		// read 6 byte packet
		if (updateGloveData()) break;
		gloveGraph.test(*this);
	}
	return 0;
}
***************/
